// Generated by CoffeeScript 1.8.0
(function() {
  var checkingStatus, env, page, runCoverage, system;

  page = require('webpage').create();

  system = require('system');

  env = system.env;

  page.nbFailure = 0;

  console.log("phantomjs: Running tests at " + system.env.ROOT_URL + " using test-in-console and coverage");

  page.onConsoleMessage = function(message) {
    return console.log(message);
  };

  page.open(system.env.ROOT_URL);

  page.onError = function(msg, trace) {
    var mochaIsRunning;
    mochaIsRunning = page.evaluate(function() {
      return window.mochaIsRunning;
    });
    if (mochaIsRunning) {
      return;
    }
    console.log("phantomjs: " + msg);
    trace.forEach(function(item) {
      return console.log("    " + item.file + ": " + item.line);
    });
    page.nbFailure++;
    if (page.nbFailure < 15) {
      console.log("Some error occured on the client side. Relaunching (" + page.nbFailure + "/15)");
      page.open(system.env.ROOT_URL);
      return;
    }
    return phantom.exit(6);
  };

  page.onCallback = function(data) {
    if (data && data.err) {
      console.log("coverage error: " + data.err);
      return phantom.exit(7);
    } else {
      return phantom.exit(0);
    }
  };

  checkingStatus = setInterval(function() {
    var done, error, exportCobertura, exportCoverageDump, exportHtml, exportJson, exportJsonSummary, exportLcov, exportLcovonly, exportRemap, exportTeamcity, exportText, exportTextLcov, exportTextSummary, failures, importCoverageDump;
    done = page.evaluate(function() {
      if (typeof TEST_STATUS !== "undefined" && TEST_STATUS !== null) {
        return TEST_STATUS.DONE;
      }
      if (typeof DONE !== "undefined" && DONE !== null) {
        return DONE;
      }
      return false;
    });
    if (done) {
      failures = page.evaluate(function() {
        if (typeof TEST_STATUS !== "undefined" && TEST_STATUS !== null) {
          return TEST_STATUS.FAILURES;
        }
        if (typeof FAILURES !== "undefined" && FAILURES !== null) {
          return FAILURES;
        }
        return false;
      });
      if (failures) {
        return phantom.exit(2);
      } else {
        clearInterval(checkingStatus);
        try {
          importCoverageDump = env.COVERAGE_IN_COVERAGE === "true";
          exportCoverageDump = env.COVERAGE_OUT_COVERAGE === "true";
          exportLcovonly = env.COVERAGE_OUT_LCOVONLY === "true";
          exportHtml = env.COVERAGE_OUT_HTML === "true";
          exportJson = env.COVERAGE_OUT_JSON === "true";
          exportTeamcity = env.COVERAGE_OUT_TEAMCITY === "true";
          exportJsonSummary = env.COVERAGE_OUT_JSON_SUMMARY === "true";
          exportTextSummary = env.COVERAGE_OUT_TEXT_SUMMARY === "true";
          exportCobertura = env.COVERAGE_OUT_COBERTURA === "true";
          exportLcov = env.COVERAGE_OUT_LCOV === "true";
          exportText = env.COVERAGE_OUT_TEXT === "true";
          exportTextLcov = env.COVERAGE_OUT_TEXT_LCOV === "true";
          exportRemap = env.COVERAGE_OUT_REMAP === "true";
          return page.evaluate(runCoverage, importCoverageDump, exportCoverageDump, exportLcovonly, exportHtml, exportJson, exportTeamcity, exportJsonSummary, exportTextSummary, exportCobertura, exportLcov, exportText, exportTextLcov, exportRemap);
        } catch (_error) {
          error = _error;
          return window.callPhantom({
            err: error
          });
        }
      }
    }
  }, 500);

  runCoverage = function(importCoverageDump, exportCoverageDump, exportLcovonly, exportHtml, exportJson, exportTeamcity, exportJsonSummary, exportTextSummary, exportCobertura, exportLcov, exportText, exportTextLcov, exportRemap) {
    window.assertCoverageEnabled = function(onSuccess) {
      if (!Package || !Package['meteor'] || !Package['meteor']['Meteor'] || !Package['meteor']['Meteor'].sendCoverage || !Package['meteor']['Meteor'].exportCoverage || !Package['meteor']['Meteor'].importCoverage) {
        return window.callPhantom({
          err: "Coverage package missing or not correclty launched"
        });
      } else {
        return onSuccess();
      }
    };
    window.importCoverageDump = function(onSuccess) {
      return Package['meteor']['Meteor'].importCoverage(function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to import coverage file"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.saveClientSideCoverage = function(onSuccess) {
      return Package['meteor']['Meteor'].sendCoverage(function(stats, err) {
        console.log("Tests are ok! Meteor-coverage is saving client side coverage to the server. Client js files saved ", JSON.stringify(stats));
        if (err) {
          return window.callPhantom({
            err: "Failed to send client coverage"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportLcovonlyReport = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('lcovonly', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save lcovonly coverage"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportCoverageDump = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('coverage', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save coverage dump"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportHtmlReport = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('html', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save html report"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportJsonReport = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('json', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save json report"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportTeamcityReport = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('teamcity', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save teamcity report"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportJsonSummary = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('json-summary', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save json_summary dump"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportTextSummary = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('text-summary', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save text-summary report"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportCobertura = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('cobertura', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save cobertura report"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportLcov = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('lcov', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save lcov report"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportText = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('text', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save text report"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportTextLcov = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('text-lcov', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to save text report"
          });
        } else {
          return onSuccess();
        }
      });
    };
    window.exportRemap = function(onSuccess) {
      return Package['meteor']['Meteor'].exportCoverage('remap', function(err) {
        if (err) {
          return window.callPhantom({
            err: "Failed to remap your coverage"
          });
        } else {
          return onSuccess();
        }
      });
    };
    return window.assertCoverageEnabled(function() {
      return window.saveClientSideCoverage(function() {
        var stepFurtherImportCoverageDump;
        stepFurtherImportCoverageDump = function() {
          var stepFurtherExportCoverageDump;
          stepFurtherExportCoverageDump = function() {
            var stepFurtherExportLcovOnly;
            stepFurtherExportLcovOnly = function() {
              var stepFurtherExportHtml;
              stepFurtherExportHtml = function() {
                var stepFurtherExportJson;
                stepFurtherExportJson = function() {
                  var stepFurtherExportTextSummary;
                  stepFurtherExportTextSummary = function() {
                    var stepFurtherExportCobertura;
                    stepFurtherExportCobertura = function() {
                      var stepFurtherExportLcov;
                      stepFurtherExportLcov = function() {
                        var stepFurtherExportText;
                        stepFurtherExportText = function() {
                          var stepFurtherExportRemap;
                          stepFurtherExportRemap = function() {
                            var stepFurtherExportTextLcov;
                            stepFurtherExportTextLcov = function() {
                              var stepFurtherExportTeamcity;
                              stepFurtherExportTeamcity = function() {
                                if (exportJsonSummary) {
                                  return window.exportJsonSummary(function() {
                                    return window.callPhantom({
                                      success: "true"
                                    });
                                  });
                                } else {
                                  return window.callPhantom({
                                    success: "true"
                                  });
                                }
                              };
                              if (exportTeamcity) {
                                return window.exportTeamcityReport(stepFurtherExportTeamcity);
                              } else {
                                return stepFurtherExportTeamcity();
                              }
                            };
                            if (exportTextLcov) {
                              return window.exportTextLcov(stepFurtherExportTextLcov);
                            } else {
                              return stepFurtherExportTextLcov();
                            }
                          };
                          if (exportRemap) {
                            return window.exportRemap(stepFurtherExportRemap);
                          } else {
                            return stepFurtherExportRemap();
                          }
                        };
                        if (exportText) {
                          return window.exportText(stepFurtherExportText);
                        } else {
                          return stepFurtherExportText();
                        }
                      };
                      if (exportLcov) {
                        return window.exportLcov(stepFurtherExportLcov);
                      } else {
                        return stepFurtherExportLcov();
                      }
                    };
                    if (exportCobertura) {
                      return window.exportCobertura(stepFurtherExportCobertura);
                    } else {
                      return stepFurtherExportCobertura();
                    }
                  };
                  if (exportTextSummary) {
                    return window.exportTextSummary(stepFurtherExportTextSummary);
                  } else {
                    return stepFurtherExportTextSummary();
                  }
                };
                if (exportJson) {
                  return window.exportJsonReport(stepFurtherExportJson);
                } else {
                  return stepFurtherExportJson();
                }
              };
              if (exportHtml) {
                return window.exportHtmlReport(stepFurtherExportHtml);
              } else {
                return stepFurtherExportHtml();
              }
            };
            if (exportLcovonly) {
              return window.exportLcovonlyReport(stepFurtherExportLcovOnly);
            } else {
              return stepFurtherExportLcovOnly();
            }
          };
          if (exportCoverageDump) {
            return window.exportCoverageDump(stepFurtherExportCoverageDump);
          } else {
            return stepFurtherExportCoverageDump();
          }
        };
        if (importCoverageDump) {
          return window.importCoverageDump(stepFurtherImportCoverageDump);
        } else {
          return stepFurtherImportCoverageDump();
        }
      });
    });
  };

}).call(this);
